$ verify = 'F$VERIFY(0)'
$!.. REQ2FOR.COM	BLISS .REQ file to VAX FORTRAN prototype INCLUDE file
$!.. Description/history at end of file.
$ new_module = "!*** MODULE "
$ len_newmod = F$LENGTH( new_module)
$ IF p1 .EQS. "" THEN p1 = "STARLET.I"
$ IF p2 .NES. "" THEN p1 = F$EDIT( p1 + p2, "COLLAPSE")
$ intrinsic = 0			!Explicit type definition for constants
$ IF F$ELEMENT( 1, "/", p1) .EQS. "/" THEN $ GOTO NO_QUALIFIER
$ q1 = F$ELEMENT( 1, "/", p1)	!Get qualifier name
$ p1 = F$ELEMENT( 0, "/", p1)	!Get file specification
$ q1 = F$EXTRACT(0,4,q1)
$ IF q1 .NES. "INTR" THEN $ GOTO BAD_QUALIFIER
$ intrinsic = 1
$NO_QUALIFIER:
$ p1 = F$PARSE( p1, "STARLET.I")
$ p2 = F$PARSE( "SYS$DISK:[]", ".ROF", p1)
$ OPEN /READ	SI	'p1'
$ OPEN /WRITE	SO	'p2'
$ ON CONTROL_Y THEN $ GOTO DONE
$ ON ERROR THEN $ GOTO DONE
$ cblock = 0			!Not in a comment block
$LOOP:
$ READ /END_OF_FILE=DONE  SI	line
$ IF F$EXTRACT(0, len_newmod, line) .EQS. new_module THEN $ GOTO NEW_MODULE
$ IF F$EXTRACT(0,1,line) .EQS. "!" THEN $ GOTO COMMENT_LINE
$ IF cblock THEN $ WRITE SO	"C"
$ cblock = 0
$ deftype = F$EDIT( F$ELEMENT( 0, " ", line), "UPCASE")
$ IF deftype .EQS. "LITERAL" THEN $ GOTO LITERAL_DEF
$ IF deftype .EQS. "MACRO" THEN $ GOTO MACRO_DEF
$COPY_LINE:
$ WRITE SO	line
$ GOTO LOOP
$COMMENT_LINE:
$ line = " " + F$EDIT( line - "!", "TRIM")
$ IF .NOT. cblock THEN $ WRITE SO	"C"
$ cblock = 1
$ WRITE SO	"C",line
$ GOTO LOOP
$NEW_MODULE:
$ line = F$ELEMENT( 0, " ",  F$EDIT( line - new_module, "TRIM"))
$ WRITE SYS$OUTPUT  "  Starting module ",line
$ WRITE SO	""
$ WRITE SO	"C+ ",line
$ cblock = 1
$ GOTO LOOP
$LITERAL_DEF:			!"LITERAL name = value;"
$ name = F$EDIT( F$ELEMENT( 1, " ", line), "UPCASE")
$ name = F$ELEMENT( 0, " ", name)
$ comment = F$EDIT( F$ELEMENT( 1, "!", line), "LOWERCASE,TRIM")
$ IF comment .EQS. "!" THEN comment = ""
$ IF comment .NES. "" THEN comment = "!" + comment
$ value = F$ELEMENT( 0, ";", F$ELEMENT( 1, "=", F$EDIT( line, "COLLAPSE")))
$ value = F$INTEGER( value)
$ type = F$EXTRACT(0,1, F$ELEMENT( 1, "$", name))
$ IF type .EQS. "M" THEN $ GOTO MASK_DEF
$ extra_tabs = ""
$ IF F$LENGTH( name) .LT. 16 THEN extra_tabs = "	"
$ IF intrinsic THEN $ GOTO INTRINSIC_LITERAL
$ WRITE SO	"	INTEGER*4 ",name,extra_tabs,"	",comment
$ WRITE SO	"	PARAMETER (",name,"=",value,")"
$ GOTO LOOP
$INTRINSIC_LITERAL:
$ WRITE SO	"	PARAMETER ",name," = ",value,"	",comment
$ GOTO LOOP
$MASK_DEF:			!Literal is a bit mask...
$ value = "X" + F$FAO( "!XL", value)
$ value = value - "X0000000" - "X000000" - "X00000" - "X0000" - "X000" - "X00"
$ IF F$LENGTH(value) .GT. 6 THEN extra_tabs = ""
$ IF intrinsic THEN $ GOTO INTRINSIC_MASK
$ WRITE SO	"	INTEGER*4 ",name,extra_tabs,"	",comment
$ WRITE SO	"	PARAMETER (",name,"='",value,"'X)"
$ GOTO LOOP
$INTRINSIC_MASK:
$ WRITE SO	"	PARAMETER ",name," = '",value,"'X	",comment
$ GOTO LOOP
$MACRO_DEF:			!"MACRO nqme = o,p,s,e%;"
$ name = F$EDIT( F$ELEMENT( 1, " ", line), "UPCASE")
$ name = F$ELEMENT( 0, " ", name)
$ comment = F$EDIT( F$ELEMENT( 1, "!", line), "LOWERCASE,TRIM")
$ IF comment .EQS. "!" THEN comment = ""
$ IF comment .NES. "" THEN comment = "!" + comment
$ value = F$ELEMENT( 0, "%", F$ELEMENT( 1, "=", F$EDIT( line, "COLLAPSE")))
$ byte_offset = F$INTEGER( F$ELEMENT( 0, ",", value))
$ bit_offset = F$INTEGER( F$ELEMENT( 1, ",", value))
$ bit_size = F$INTEGER( F$ELEMENT( 2, ",", value))
$ extension = F$INTEGER( F$ELEMENT( 3, ",", value))
$ type = F$EXTRACT(0,1, F$ELEMENT( 1, "$", name))
$ IF type .EQS. "V" THEN $ GOTO BITOFFSET_DEF
$ name = F$EDIT( name, "LOWERCASE")
$ atomic = ""
$ array = ""
$ atom_bits = 8
$ IF type .EQS. "W" THEN atom_bits = 16
$ IF type .EQS. "L" THEN atom_bits = 32
$ n = bit_size/atom_bits
$ IF n*atom_bits .NE. bit_size THEN $ GOTO UNKNOWN_TYPE
$ atomic = "BYTE "
$ IF atom_bits .EQ. 16 THEN atomic = "INTEGER*2 "
$ IF atom_bits .EQ. 32 THEN atomic = "INTEGER*4 "
$ IF n .GT. 1 THEN array = "(" + F$STRING(n) + ")"
$ IF type .EQS. "T" THEN $ GOTO CHAR_TYPE
$UNKNOWN_TYPE:
$ WRITE SO	"	  ",atomic,name,array,"	",comment
$ GOTO LOOP
$CHAR_TYPE:
$ WRITE SO	"	  CHARACTER*",n," ",name,"	",comment
$ GOTO LOOP
$BITOFFSET_DEF:
$ extra_tabs = ""
$ IF F$LENGTH( name) .LT. 16 THEN extra_tabs = "	"
$ IF intrinsic THEN $ GOTO INTRINSIC_OFFSET
$ WRITE SO	"	INTEGER*4 ",name,extra_tabs,"	",comment
$ WRITE SO	"	PARAMETER (",name,"=",bit_offset,")"
$ GOTO LOOP
$INTRINSIC_OFFSET:
$ WRITE SO	"	PARAMETER ",name," = ",bit_offset,"	",comment
$ GOTO LOOP
$DONE:
$ CLOSE SI
$ CLOSE SO
$ p2 = p2 - F$PARSE( p2,,, "VERSION")
$ EDIT/EDT/NOCOMMAND  'p2'
EXIT
$ PURGE  'p2'
$ EXIT	F$VERIFY(verify).OR.1
$BAD_QUALIFIER:
$ TYPE SYS$INPUT:
%REQ2FOR-F-BADQUAL, unknown qualifier (not /INTRINSIC) found
$ EXIT	F$VERIFY(verify).OR.1
$!=============================================================================
$!+ REQ2FOR
$! Perform many of the repetitive operations necessary to convert a BLISS .REQ
$! file into a prototype of INCLUDE files for VAX FORTRAN.
$!
$!	@REQ2FOR  [input]
$!
$! The parameter is the input file specification, the default is STARLET.I
$! which is an editted version of STARLET.REQ.  The output is placed in the
$! file using the filename of the input file and the file type ".ROF".
$!/INTRINSIC
$! If this qualifier is used on the input file, then the output file will
$! define constants using parameter statements of the form:
$!
$!	PARAMETER  name = value
$!
$! Otherwise, the default action is to define constants using the pair of
$! statements:
$!
$!	INTEGER*4 name
$!	PARAMETER (name = value)
$!
$!-
$!=============================================================================
$! Modifications:
$!  01-Nov-85	FJN	Created
$!  17-Jun-86	FJN	Added support for /INTRINSIC
