$ verify = 'F$VERIFY(0)'
$!.. REQ2H.COM			BLISS .REQ file to VAX C .H prototype file
$!.. Description/history at end of file.
$ new_module = "!*** MODULE "
$ len_newmod = F$LENGTH( new_module)
$ IF p1 .EQS. "" THEN p1 = "STARLET.I"
$ p1 = F$PARSE( p1, "STARLET.I")
$ p2 = F$PARSE( "SYS$DISK:[]", ".O", p1)
$ OPEN /READ	SI	'p1'
$ OPEN /WRITE	SO	'p2'
$ ON CONTROL_Y THEN $ GOTO DONE
$ ON ERROR THEN $ GOTO DONE
$ cblock = 0			!Not in a comment block
$LOOP:
$ READ /END_OF_FILE=DONE  SI	line
$ IF F$EXTRACT(0, len_newmod, line) .EQS. new_module THEN $ GOTO NEW_MODULE
$ IF F$EXTRACT(0,1,line) .EQS. "!" THEN $ GOTO COMMENT_LINE
$ IF cblock THEN $ WRITE SO	"*/"
$ cblock = 0
$ deftype = F$EDIT( F$ELEMENT( 0, " ", line), "UPCASE")
$ IF deftype .EQS. "LITERAL" THEN $ GOTO LITERAL_DEF
$ IF deftype .EQS. "MACRO" THEN $ GOTO MACRO_DEF
$COPY_LINE:
$ WRITE SO	line
$ GOTO LOOP
$COMMENT_LINE:
$ line = " " + F$EDIT( line - "!", "TRIM")
$ IF .NOT. cblock THEN $ WRITE SO	"/*"
$ cblock = 1
$ WRITE SO	line
$ GOTO LOOP
$NEW_MODULE:
$ line = F$ELEMENT( 0, " ",  F$EDIT( line - new_module, "TRIM"))
$ WRITE SYS$OUTPUT  "  Starting module ",line
$ WRITE SO	""
$ WRITE SO	"/*+ ",line
$ cblock = 1
$ GOTO LOOP
$LITERAL_DEF:			!"LITERAL name = value;"
$ name = F$EDIT( F$ELEMENT( 1, " ", line), "UPCASE")
$ name = F$ELEMENT( 0, " ", name)
$ comment = F$EDIT( F$ELEMENT( 1, "!", line), "LOWERCASE,TRIM")
$ IF comment .EQS. "!" THEN comment = ""
$ IF comment .NES. "" THEN comment = "	/* " + comment + " */"
$ value = F$ELEMENT( 0, ";", F$ELEMENT( 1, "=", F$EDIT( line, "COLLAPSE")))
$ value = F$INTEGER( value)
$ type = F$EXTRACT(0,1, F$ELEMENT( 1, "$", name))
$ IF type .EQS. "M" THEN $ GOTO MASK_DEF
$ extra_tabs = ""
$ IF F$LENGTH( name) .LT. 16 THEN extra_tabs = "	"
$ IF value .LT. 0 THEN $ GOTO NEGATIVE_VALUE
$ WRITE SO	"#define ",name,extra_tabs,"	",value,comment
$ GOTO LOOP
$NEGATIVE_VALUE:
$ WRITE SO	"#define ",name,extra_tabs,"	(",value,")",comment
$ GOTO LOOP
$MASK_DEF:			!Literal is a bit mask...
$ value = "X" + F$FAO( "!XL", value)
$ value = value - "X0000000" - "X000000" - "X00000" - "X0000" - "X000" - "X00"
$ IF F$LENGTH(value) .GT. 6 THEN extra_tabs = ""
$ WRITE SO	"#define ",name,extra_tabs,"	0X",value,comment
$ GOTO LOOP
$MACRO_DEF:			!"MACRO nqme = o,p,s,e%;"
$ name = F$EDIT( F$ELEMENT( 1, " ", line), "UPCASE")
$ name = F$ELEMENT( 0, " ", name)
$ comment = F$EDIT( F$ELEMENT( 1, "!", line), "LOWERCASE,TRIM")
$ IF comment .EQS. "!" THEN comment = ""
$ IF comment .NES. "" THEN comment = "	/* " + comment + " */"
$ value = F$ELEMENT( 0, "%", F$ELEMENT( 1, "=", F$EDIT( line, "COLLAPSE")))
$ byte_offset = F$INTEGER( F$ELEMENT( 0, ",", value))
$ bit_offset = F$INTEGER( F$ELEMENT( 1, ",", value))
$ bit_size = F$INTEGER( F$ELEMENT( 2, ",", value))
$ extension = F$INTEGER( F$ELEMENT( 3, ",", value))
$ type = F$EXTRACT(0,1, F$ELEMENT( 1, "$", name))
$ IF type .EQS. "V" THEN $ GOTO BITOFFSET_DEF
$ name = F$EDIT( name, "LOWERCASE")
$ ext = ""
$ IF extension .EQ. 0 THEN ext = "unsigned "
$ atomic = ""
$ array = ""
$ atom_bits = 8
$ IF type .EQS. "W" THEN atom_bits = 16
$ IF type .EQS. "L" THEN atom_bits = 32
$ n = bit_size/atom_bits
$ IF n*atom_bits .NE. bit_size THEN $ GOTO UNKNOWN_TYPE
$ atomic = "char "
$ IF atom_bits .EQ. 16 THEN atomic = "short "
$ IF atom_bits .EQ. 32 THEN atomic = "long "
$ IF n .GT. 1 THEN array = "[" + F$STRING(n) + "]"
$UNKNOWN_TYPE:
$ WRITE SO	"    ",ext,atomic,name,array,";	",comment
$ GOTO LOOP
$BITOFFSET_DEF:
$ extra_tabs = ""
$ IF F$LENGTH( name) .LT. 16 THEN extra_tabs = "	"
$ WRITE SO	"#define ",name,extra_tabs,"	",bit_offset,comment
$ GOTO LOOP
$DONE:
$ CLOSE SI
$ CLOSE SO
$ p2 = p2 - F$PARSE( p2,,, "VERSION")
$ EDIT/EDT/NOCOMMAND  'p2'
EXIT
$ PURGE  'p2'
$ EXIT	F$VERIFY(verify).OR.1
$!=============================================================================
$!+ REQ2H
$! Perform many of the repetitive operations necessary to convert a BLISS .REQ
$! file into a prototype of .H files for VAX C.
$!
$!	@REQ2H  [input]
$!
$! The parameter is the input file specification, the default is STARLET.I
$! which is an editted version of STARLET.REQ.  The output is placed in the
$! file using the filename of the input file and the file type ".O".
$!-
$!=============================================================================
$! Modifications:
$!  20-Oct-85	FJN	Created
$!  01-Nov-85	FJN	Expanded conversion of comment blocks and module
$!			headers
