/*+ $DQFDEF
  Module ($DQFDEF) of SYS$LIBRARY:LCLCDEF.TLB.

 Defines the DQF structure for the disk quota file record used with
 the ACPCONTROL I/O function.
-*/
/* Extracted $DQFDEF from SYS$LIBRARY:LIB on  7-JUL-1983*/

#define  DQF$C_LENGTH    0X20	/* Length of the record in bytes */
#define  DQF$K_LENGTH    0X20	/* Length of the record in bytes */

struct	DQF {
	unsigned long dqf$l_flags;	/* Flags longword */
#define  DQF$M_ACTIVE    0X01	/* Record contains active entry */
#define  DQF$V_ACTIVE    0	/* Record contains active entry */
	unsigned long dqf$l_uic;	/* UIC of this record */
	unsigned long dqf$l_usage;	/* Number of blocks in use */
	unsigned long dqf$l_permquota;	/* Permanent disk quota */
	unsigned long dqf$l_overdraft;	/* Overdraft limit */
	unsigned	: 32;
	unsigned	: 32;
	unsigned	: 32;
	};
/*
  End of $DQFDEF module.
*/
