$	VERIFY = F$VERIFY(0)
$	ON ERROR THEN GOTO EXIT
$!-------------------------------------------------------------------------
$!
$!	ENV.COM	Generate an LSE environment file from LSE source 
$!
$!	@BUILD_ENV:ENV.COM  LSE-file  ENV-file
$!
$!	LSE-file	Input LSE file containing LSE commands
$!	ENV-file	Output LSE file containing LSE environment
$!
$!-------------------------------------------------------------------------
$!
$!
$! Define tools and files used.
$!
$!
$	LSEDIT    := ""
$	NEXTVER   := @BUILD_ENV:NEXTVER.COM  SYS$SCRATCH:ENV.SCR
$!
$!
$! Get the LSE_FILE parameter.
$!
$!
$	LSE_FILE    :=    'P1'
$	IF    "''F$MODE()'" .EQS. "BATCH"    THEN GOTO LSE_FILE2
$LSE_FILE1:	
$	IF    LSE_FILE .NES. ""    THEN GOTO LSE_FILE2
$	INQUIRE    LSE_FILE    "$_LSE file"
$	GOTO  LSE_FILE1
$LSE_FILE2:
$!
$!
$! Get the ENV_FILE parameter.
$!
$!
$	ENV_FILE    :=    'P2'
$	IF    "''F$MODE()'" .EQS. "BATCH"    THEN GOTO ENV_FILE2
$ENV_FILE1:	
$	IF    ENV_FILE .NES. ""    THEN GOTO ENV_FILE2
$	INQUIRE    ENV_FILE    "$_environment file"
$	GOTO  ENV_FILE1
$ENV_FILE2:
$!
$!
$! Create the initialization file.
$!
$!
$	NEXTVER  INIT_FILE
$	OPEN/WRITE/ERROR=ERROR_EXIT  INIT_FILE  'INIT_FILE'
$	WRITE INIT_FILE  "GOTO BUFFER INIT/READ/CREATE"
$	WRITE INIT_FILE  "READ ''LSE_FILE'"
$	WRITE INIT_FILE  "DO"
$	WRITE INIT_FILE  "SAVE ENVIRONMENT/NEW ''ENV_FILE'"
$	WRITE INIT_FILE  "EXIT"
$	CLOSE INIT_FILE
$!
$!
$! Invoke LSE and produce the environment file.
$!
$	ASSING/USER_MODE  NL:           SYS$OUTPUT
$	ASSIGN/USER_MODE  SYS$COMMAND:  SYS$INPUT:
$	LSEDIT -
	  /INITIALIZATION='INIT_FILE'	-
	  /NOENVIRONMENT -
	  /READONLY			SYS$SCRATCH:ENV.TMP	! dummy input
$!
$!
$! Exit on ERROR or CTRL_Y
$!
$!
$	STATUS = 1	! successful completion
$	GOTO EXIT
$ERROR_EXIT:
$	STATUS =$STATUS
$EXIT:
$ 	SET NOON   ! Disable ON WARNING, ON ERROR processing
$!
$	IF "''INIT_FILE'" .EQS. ""  THEN GOTO EXIT
$	IF F$SEARCH(INIT_FILE)  .NES. ""  THEN DELETE 'INIT_FILE'
$	DELETE/SYMBOL/GLOBAL  INIT_FILE
$!
$	EXIT STATUS .OR. (F$VERIFY(VERIFY) .AND. 0)
