$!
$! remove any lock files left from previous operation
$!
$ file = f$search("st_msg:*.lck.*")
$ if file .nes. "" then delete st_msg:*.lck.*
$!
$! rename any files left for mflush to assure no collision in file name space
$!
$ set noon
$ file = f$search("st_msg:temp.sav.*")
$ if file .nes. "" then delete st_msg:temp.sav.*
$ drtnst:
$	file = f$search("st_msg:dreturn.*")
$	if file .eqs. "" then goto drtnen
$	write sys$output "Startmail - saving Dreturn files"
$	copy nla0: st_msg:temp.sav.1
$	rename st_msg:dreturn.* st_msg:temp.sav
$	rename st_msg:temp.sav.* st_msg:dreturn.sav.*
$	delete st_msg:dreturn.sav.1
$ drtnen:
$ mrtnst:
$	file = f$search("st_msg:mreturn.*")
$	if file .eqs. "" then goto mrtnen
$	write sys$output "Startmail - saving Mreturn files"
$	copy nla0: st_msg:temp.sav.1
$	rename st_msg:mreturn.* st_msg:temp.sav
$	rename st_msg:temp.sav.* st_msg:mreturn.sav.*
$	delete st_msg:mreturn.sav.1
$ mrtnen:
$ ftryst:
$	file = f$search("st_msg:fretry.*")
$	if file .eqs. "" then goto ftryen
$	write sys$output "Startmail - saving Fretry files"
$	copy nla0: st_msg:temp.sav.1
$	rename st_msg:fretry.* st_msg:temp.sav
$	rename st_msg:temp.sav.* st_msg:fretry.sav.*
$	delete st_msg:fretry.sav.1
$ ftryen:
$ stryst:
$	file = f$search("st_msg:sretry.*")
$	if file .eqs. "" then goto stryen
$	write sys$output "Startmail - saving Sretry files"
$	copy nla0: st_msg:temp.sav.1
$	rename st_msg:sretry.* st_msg:temp.sav
$	rename st_msg:temp.sav.* st_msg:sretry.sav.*
$	delete st_msg:sretry.sav.1
$ stryen:
$ vtryst:
$	file = f$search("st_msg:vretry.*")
$	if file .eqs. "" then goto vtryen
$	write sys$output "Startmail - saving Vretry files"
$	copy nla0: st_msg:temp.sav.1
$	rename st_msg:vretry.* st_msg:temp.sav
$	rename st_msg:temp.sav.* st_msg:vretry.sav.*
$	delete st_msg:vretry.sav.1
$ vtryen:
$!
$! locate images for delivery system processes: Mflush, Mailer and Delivr
$!
$ mflush := st_bin:mflush.exe
$ open/read/error=c1 dcl_file st_usr:mflush.exe
$ close dcl_file
$ mflush := st_usr:mflush.exe
$ c1:
$ delivr := st_bin:delivr.exe
$ open/read/error=c2 dcl_file st_usr:delivr.exe
$ close dcl_file
$ delivr := st_usr:delivr.exe
$ c2:
$ mailer := st_bin:mailer.exe
$ open/read/error=c3 dcl_file st_usr:mailer.exe
$ close dcl_file
$ mailer := st_usr:mailer.exe
$ c3:
$!
$! Delivr needs to create files with this protection
$!
$ set prot=(w:r,g:r)/default
$ write sys$output "Startmail - starting Delivr = ''delivr'"
$ run/out=nla0:/input=nla0:/err=nla0:/process_name="delivr"/prio=3-
/subp=10/file=75/buffer=20480/page=51200/queue=40/ast_limit=10/uic=[10,1]-
/priv=(nosame,sysnam,grpnam,group,tmpmbx,world,netmbx,oper,syslck,exquota)-
 'delivr'
$!
$! Give Delivr time to startup
$!
$ wait 00:00:05		! wait 5 seconds
$!
$! Mailer and Mflush prevent the world from looking at their files
$!
$ set prot=(w,g)/default
$ write sys$output "Startmail - starting Mailer = ''mailer'"
$ run/out=nla0:/input=nla0:/err=nla0:/process_name="mailer"/prio=4-
/subp=0/file=15/buffer=4096/page=10240/queue=8/ast_limit=10/uic=[10,1]-
/priv=(nosame,sysnam,grpnam,group,tmpmbx,world,netmbx,exquota)-
 'mailer'
$ write sys$output "Startmail - starting Mflush = ''mflush'"
$ run/out=nla0:/input=nla0:/err=nla0:/process_name="mflush"/prio=4-
/subp=10/file=75/buffer=20480/page=51200/queue=40/ast_limit=10/uic=[10,1]-
/priv=(nosame,sysnam,grpnam,group,tmpmbx,world,netmbx,exquota,syslck)-
 'mflush'
$!
$! reset protection
$!
$ set prot=(w:r,g:r)/default
$!
$! If you need to startup site-dependent server processes (receivers listening
$! in on a particular network link), include the command file invocations here
$!
$! For example, at LBL we need to start up a receiver on our Hyperchannel
$! connection.  This is done by uncommenting the line below.
$!
$! @dba0:[netmail]starthyp
$!
$! reset default protection for further processing in systartup.com
$!
$ set prot=(g:rwe,w:r)/default
