!
! Descriptions to build TRMPRINT.EXE
!
TRMPRINT.EXE	: TRMPRINT.OBJ, TRMMESS.OBJ, TRMTABLES.OBJ
		$(LINK) $(LINKFLAGS) $(MMS$SOURCE_LIST)

TRMPRINT.OBJ	: TRMPRINT.FOR

TRMMESS.OBJ	: TRMMESS.MSG

TRMTABLES.OBJ	: TRMPRINT.CLD
		SET COMMAND /OBJECT=$(MMS$TARGET_NAME) $(CLDFLAGS) $(MMS$SOURCE)

.LAST		:
	@	PURGE
!
! Make listing files 
!
LISTINGS	: TRMPRINT.LIS, TRMMESS.LIS, TRMTABLES.LIS
	@	DIRECTORY /SIZE  *.LIS

TRMPRINT.LIS	: TRMPRINT.FOR
		FORTRAN /LIST=$(MMS$TARGET_NAME) /NOOBJECT $(MMS$SOURCE)

TRMMESS.LIS	: TRMMESS.MSG
		MESSAGE /LIST=$(MMS$TARGET_NAME) /NOOBJECT $(MMS$SOURCE)

TRMTABLES.LIS	: TRMPRINT.CLD
		SET COMMAND /LIST=$(MMS$TARGET_NAME) /NOOBJECT $(MMS$SOURCE)
!
! Cleanup object files
!
CLEANUP		:
	-	DELETE *.OBJ;*,*.LIS;*
