/*+ $SMGDEF
 Definitions for RTL Screen Management
 Extracted from V4.4 SYS$LIBRARY:STARLET.REQ on  10-Jun-1986

 Input terminator codes
 Control characters
*/
#define SMG$K_TRM_CTRLA		1	/* soh */
#define SMG$K_TRM_CTRLB		2	/* stx */
#define SMG$K_TRM_CTRLC		3	/* etx */
#define SMG$K_TRM_CTRLD		4	/* eot */
#define SMG$K_TRM_CTRLE		5	/* enq */
#define SMG$K_TRM_CTRLF		6	/* ack */
#define SMG$K_TRM_CTRLG		7	/* bel */
#define SMG$K_TRM_CTRLH		8	/* bs */
#define SMG$K_TRM_CTRLI		9	/* ht */
#define SMG$K_TRM_CTRLJ		10	/* lf */
#define SMG$K_TRM_CTRLK		11	/* vt */
#define SMG$K_TRM_CTRLL		12	/* ff */
#define SMG$K_TRM_CTRLM		13	/* cr */
#define SMG$K_TRM_CTRLN		14	/* so */
#define SMG$K_TRM_CTRLO		15	/* si */
#define SMG$K_TRM_CTRLP		16	/* dle */
#define SMG$K_TRM_CTRLQ		17	/* dc1 */
#define SMG$K_TRM_CTRLR		18	/* dc2 */
#define SMG$K_TRM_CTRLS		19	/* dc3 */
#define SMG$K_TRM_CTRLT		20	/* dc4 */
#define SMG$K_TRM_CTRLU		21	/* nak */
#define SMG$K_TRM_CTRLV		22	/* syn */
#define SMG$K_TRM_CTRLW		23	/* etb */
#define SMG$K_TRM_CTRLX		24	/* can */
#define SMG$K_TRM_CTRLY		25	/* em */
#define SMG$K_TRM_CTRLZ		26	/* sub */
#define SMG$K_TRM_ESCAPE	27	/* esc */
					/* FS */
					/* GS */
					/* RS */
					/* US */
#define SMG$K_TRM_SPACE		32	/* sp */
#define SMG$K_TRM_EXCLAMATION_POINT 33	/* ! */
#define SMG$K_TRM_DOUBLE_QUOTE	34	/* " */
#define SMG$K_TRM_NUMBER_SIGN	35	/* # */
#define SMG$K_TRM_DOLLAR_SIGN	36	/* $ */
#define SMG$K_TRM_PERCENT_SIGN	37	/* % */
#define SMG$K_TRM_AMPERSAND	38	/* & */
#define SMG$K_TRM_QUOTE		39	/* ' */
#define SMG$K_TRM_LEFT_PAREN	40	/* ( */
#define SMG$K_TRM_RIGHT_PAREN	41	/* ) */
#define SMG$K_TRM_ASTERISK	42	/* * */
#define SMG$K_TRM_PLUS_SIGN	43	/* + */
					/* , */
#define SMG$K_TRM_DASH		45	/* - */
#define SMG$K_TRM_DOT		46	/* . */
#define SMG$K_TRM_SLASH		47	/* / */
#define SMG$K_TRM_ZERO		48	/* 0 */
#define SMG$K_TRM_ONE		49	/* 1 */
#define SMG$K_TRM_TWO		50	/* 2 */
#define SMG$K_TRM_THREE		51	/* 3 */
#define SMG$K_TRM_FOUR		52	/* 4 */
#define SMG$K_TRM_FIVE		53	/* 5 */
#define SMG$K_TRM_SIX		54	/* 6 */
#define SMG$K_TRM_SEVEN		55	/* 7 */
#define SMG$K_TRM_EIGHT		56	/* 8 */
#define SMG$K_TRM_NINE		57	/* 9 */
#define SMG$K_TRM_COLON		58	/* : */
#define SMG$K_TRM_SEMICOLON	59	/* ; */
#define SMG$K_TRM_LESS_THAN	60	/* < */
#define SMG$K_TRM_EQUAL		61	/* = */
#define SMG$K_TRM_GREATER_THAN	62	/* > */
#define SMG$K_TRM_QUESTION_MARK	63	/* ? */
#define SMG$K_TRM_AT_SIGN	64	/* @ */
#define SMG$K_TRM_UPPERCASE_A	65	/* a */
#define SMG$K_TRM_UPPERCASE_B	66	/* b */
#define SMG$K_TRM_UPPERCASE_C	67	/* c */
#define SMG$K_TRM_UPPERCASE_D	68	/* d */
#define SMG$K_TRM_UPPERCASE_E	69	/* e */
#define SMG$K_TRM_UPPERCASE_F	70	/* f */
#define SMG$K_TRM_UPPERCASE_G	71	/* g */
#define SMG$K_TRM_UPPERCASE_H	72	/* h */
#define SMG$K_TRM_UPPERCASE_I	73	/* i */
#define SMG$K_TRM_UPPERCASE_J	74	/* j */
#define SMG$K_TRM_UPPERCASE_K	75	/* k */
#define SMG$K_TRM_UPPERCASE_L	76	/* l */
#define SMG$K_TRM_UPPERCASE_M	77	/* m */
#define SMG$K_TRM_UPPERCASE_N	78	/* n */
#define SMG$K_TRM_UPPERCASE_O	79	/* o */
#define SMG$K_TRM_UPPERCASE_P	80	/* p */
#define SMG$K_TRM_UPPERCASE_Q	81	/* q */
#define SMG$K_TRM_UPPERCASE_R	82	/* r */
#define SMG$K_TRM_UPPERCASE_S	83	/* s */
#define SMG$K_TRM_UPPERCASE_T	84	/* t */
#define SMG$K_TRM_UPPERCASE_U	85	/* u */
#define SMG$K_TRM_UPPERCASE_V	86	/* v */
#define SMG$K_TRM_UPPERCASE_W	87	/* w */
#define SMG$K_TRM_UPPERCASE_X	88	/* x */
#define SMG$K_TRM_UPPERCASE_Y	89	/* y */
#define SMG$K_TRM_UPPERCASE_Z	90	/* z */
#define SMG$K_TRM_LEFT_BRACKET	91	/* [ */
#define SMG$K_TRM_BACKSLASH	92	/* \ */
#define SMG$K_TRM_RIGHT_BRACKET	93	/* ] */
#define SMG$K_TRM_CARET		94	/* ^ */
#define SMG$K_TRM_UNDERLINE	95	/* _ */
#define SMG$K_TRM_GRAVE_ACCENT	96	/* ` */
#define SMG$K_TRM_LOWERCASE_A	97	/* a */
#define SMG$K_TRM_LOWERCASE_B	98	/* b */
#define SMG$K_TRM_LOWERCASE_C	99	/* c */
#define SMG$K_TRM_LOWERCASE_D	100	/* d */
#define SMG$K_TRM_LOWERCASE_E	101	/* e */
#define SMG$K_TRM_LOWERCASE_F	102	/* f */
#define SMG$K_TRM_LOWERCASE_G	103	/* g */
#define SMG$K_TRM_LOWERCASE_H	104	/* h */
#define SMG$K_TRM_LOWERCASE_I	105	/* i */
#define SMG$K_TRM_LOWERCASE_J	106	/* j */
#define SMG$K_TRM_LOWERCASE_K	107	/* k */
#define SMG$K_TRM_LOWERCASE_L	108	/* l */
#define SMG$K_TRM_LOWERCASE_M	109	/* m */
#define SMG$K_TRM_LOWERCASE_N	110	/* n */
#define SMG$K_TRM_LOWERCASE_O	111	/* o */
#define SMG$K_TRM_LOWERCASE_P	112	/* p */
#define SMG$K_TRM_LOWERCASE_Q	113	/* q */
#define SMG$K_TRM_LOWERCASE_R	114	/* r */
#define SMG$K_TRM_LOWERCASE_S	115	/* s */
#define SMG$K_TRM_LOWERCASE_T	116	/* t */
#define SMG$K_TRM_LOWERCASE_U	117	/* u */
#define SMG$K_TRM_LOWERCASE_V	118	/* v */
#define SMG$K_TRM_LOWERCASE_W	119	/* w */
#define SMG$K_TRM_LOWERCASE_X	120	/* x */
#define SMG$K_TRM_LOWERCASE_Y	121	/* y */
#define SMG$K_TRM_LOWERCASE_Z	122	/* z */
#define SMG$K_TRM_LEFT_BRACE	123	/* left curly brace */
#define SMG$K_TRM_VERTICAL_LINE	124	/* | */
#define SMG$K_TRM_RIGHT_BRACE	125	/* right curly brace */
#define SMG$K_TRM_TILDE		126	/* ~ */
#define SMG$K_TRM_DELETE	127	/* del */
/*
 Synonyms for control characters
*/
#define SMG$K_TRM_BS		8
#define SMG$K_TRM_HT		9
#define SMG$K_TRM_LF		10
#define SMG$K_TRM_CR		13
/*
 Keypad keys
*/
#define SMG$K_TRM_PF1		256
#define SMG$K_TRM_PF2		257
#define SMG$K_TRM_PF3		258
#define SMG$K_TRM_PF4		259
#define SMG$K_TRM_KP0		260
#define SMG$K_TRM_KP1		261
#define SMG$K_TRM_KP2		262
#define SMG$K_TRM_KP3		263
#define SMG$K_TRM_KP4		264
#define SMG$K_TRM_KP5		265
#define SMG$K_TRM_KP6		266
#define SMG$K_TRM_KP7		267
#define SMG$K_TRM_KP8		268
#define SMG$K_TRM_KP9		269
#define SMG$K_TRM_ENTER		270
#define SMG$K_TRM_MINUS		271
#define SMG$K_TRM_COMMA		272
#define SMG$K_TRM_PERIOD	273	/* cursor positioning keys */
#define SMG$K_TRM_UP		274
#define SMG$K_TRM_DOWN		275
#define SMG$K_TRM_LEFT		276
#define SMG$K_TRM_RIGHT		277
/*
 Function keys
*/
#define SMG$K_TRM_F1		281
#define SMG$K_TRM_F2		282
#define SMG$K_TRM_F3		283
#define SMG$K_TRM_F4		284
#define SMG$K_TRM_F5		285
#define SMG$K_TRM_F6		286
#define SMG$K_TRM_F7		287
#define SMG$K_TRM_F8		288
#define SMG$K_TRM_F9		289
#define SMG$K_TRM_F10		290
#define SMG$K_TRM_F11		291
#define SMG$K_TRM_F12		292
#define SMG$K_TRM_F13		293
#define SMG$K_TRM_F14		294
#define SMG$K_TRM_HELP		295	/* f15 */
#define SMG$K_TRM_DO		296	/* f16 */
#define SMG$K_TRM_F17		297
#define SMG$K_TRM_F18		298
#define SMG$K_TRM_F19		299
#define SMG$K_TRM_F20		300
/*
 Synonyms for function keys
*/
#define SMG$K_TRM_F15		295
#define SMG$K_TRM_F16		296
/*
 Editing keys
*/
#define SMG$K_TRM_FIND		311	/* e1 */
#define SMG$K_TRM_INSERT_HERE	312	/* e2 */
#define SMG$K_TRM_REMOVE	313	/* e3 */
#define SMG$K_TRM_SELECT	314	/* e4 */
#define SMG$K_TRM_PREV_SCREEN	315	/* e5 */
#define SMG$K_TRM_NEXT_SCREEN	316	/* e6 */
/*
 Synonyms for editing keys
*/
#define SMG$K_TRM_E1		311	/* find */
#define SMG$K_TRM_E2		312	/* insert_here */
#define SMG$K_TRM_E3		313	/* remove */
#define SMG$K_TRM_E4		314	/* select */
#define SMG$K_TRM_E5		315	/* prev_screen */
#define SMG$K_TRM_E6		316	/* next_screen */
/*
 Conditions
*/
#define SMG$K_TRM_CANCELLED	508	/* i/o cancelled by smg$cancel_input */
#define SMG$K_TRM_TIMEOUT	509	/* timeout period expired */
#define SMG$K_TRM_BUFFER_FULL	510	/* buffer is full */
#define SMG$K_TRM_UNKNOWN	511	/* unknown terminator */
/*
 Key definition attributes
*/
#define SMG$M_KEY_NOECHO	0X1
#define SMG$M_KEY_TERMINATE	0X2
#define SMG$M_KEY_LOCK		0X4
#define SMG$M_KEY_PROTECTED	0X8
#define SMG$M_KEY_SETSTATE	0X10
#define SMG$S_KEY_DEF_ATTR	4
struct SMG$R_KEY_DEF_ATTR {
    unsigned SMG$V_KEY_NOECHO : 1;      /* Don't echo strings               */
    unsigned SMG$V_KEY_TERMINATE : 1;   /* This key terminates read         */
    unsigned SMG$V_KEY_LOCK : 1;        /* Lock new state                   */
    unsigned SMG$V_KEY_PROTECTED : 1;   /* Definition is protected          */
    unsigned SMG$V_KEY_SETSTATE : 1;    /* Definition sets a state (output only) */
    } ;
/*
 SCREEN MANAGEMENT REQUEST TYPES
*/
#define SMG$C_CHANGE_RENDITION	10	/* smg$change_rendition */
#define SMG$C_DELETE_CHARS	11	/* smg$delete_chars */
#define SMG$C_ERASE_DISPLAY	12	/* smg$erase_display */
#define SMG$C_ERASE_LINE	13	/* smg$erase_line */
#define SMG$C_HOME_CURSOR	14	/* smg$home_cursor */
#define SMG$C_INSERT_CHARS	15	/* smg$insert_chars */
#define SMG$C_INSERT_LINE	16	/* smg$insert_line */
#define SMG$C_PUT_CHARS		17	/* smg$put_chars */
#define SMG$C_PUT_LINE		18	/* smg$put_line */
#define SMG$C_PUT_DISPLAY_ENCODED 19	/* smg$put_virtual_display_encoded */
#define SMG$C_RETURN_CURSOR_POS	20	/* smg$return_cursor_pos */
#define SMG$C_PUT_WITH_SCROLL	21	/* smg$put_with_scroll */
#define SMG$C_SET_CURSOR_ABS	22	/* smg$set_cursor_abs */
#define SMG$C_SET_CURSOR_REL	23	/* smg$set_cursor_rel */
#define SMG$C_DELETE_LINE	24	/* smg$delete_line */
#define SMG$C_ERASE_CHARS	25	/* smg$erase_chars */
#define SMG$C_SCROLL_DISPLAY_AREA 26	/* smg$scroll_display_area */
#define SMG$C_CHANGE_VIRTUAL_DISPLAY 27	/* smg$change_virtual_display */
#define SMG$C_LABEL_BORDER	28	/* smg$label_border */
#define SMG$C_END_DISPLAY_UPDATE 29	/* smg$end_display_update */
/*
 Character Set Codes
*/
#define SMG$C_UNITED_KINGDOM	0
#define SMG$C_ASCII		1
#define SMG$C_SPEC_GRAPHICS	2	/* special graphics */
#define SMG$C_ALT_CHAR		3	/* alternate - standard char. */
#define SMG$C_ALT_GRAPHICS	4	/* alternate - special graphics */
/*
 The following constants define corner cursor positions used in
 SMG$HOME_CURSOR.
*/
#define SMG$C_UPPER_LEFT	0
#define SMG$C_LOWER_LEFT	1
#define SMG$C_UPPER_RIGHT	2
#define SMG$C_LOWER_RIGHT	3
/*
 The following constants define label positions used in
 SMG$LABEL_BORDER.
*/
#define SMG$K_TOP		0
#define SMG$K_BOTTOM		1
#define SMG$K_LEFT		2
#define SMG$K_RIGHT		3
/*
 Define bit masks and values for screen attributes
*/
#define SMG$M_BOLD		0X1
#define SMG$M_REVERSE		0X2
#define SMG$M_BLINK		0X4
#define SMG$M_UNDERLINE		0X8
#define SMG$M_NORMAL		0X0	/* no bits set */
 
#define SMG$M_BUF_ENABLED	0X1
#define SMG$M_MINUPD		0X2
#define SMG$M_CLEAR_SCREEN	0X4
#define SMG$M_NOTABS		0X8
#define SMG$K_BUF_ENABLED	0	/* enable buffering bitvector index */
#define SMG$K_MINUPD		1	/* enable minimal update bitvector index */
#define SMG$K_CLEAR_SCREEN	2	/* clear screen on exit */
#define SMG$K_NOTABS		3	/* don't use physical tabs */
/*
 Master color wheel for screen background colors.
*/
#define SMG$C_COLOR_UNKNOWN	0
#define SMG$C_COLOR_WHITE	1
#define SMG$C_COLOR_BLACK	2
/*
 The following constants correspond to the internal types defined
 in SMGTERM.REQ.  These names used to be for public use - the SMGTERM names
 used to be needed for compatibility with SCR$ and SMG$ code.
 Use of these names is now very highly discouraged.
*/ 
#define SMG$K_UNKNOWN		0	/* non-graphics or unknown type */
#define SMG$K_VT05		1	/* vt05 series terminal */
#define SMG$K_VT52		2	/* vt52 series terminal */
#define SMG$K_VT100		3	/* vt100 series terminal */
#define SMG$K_VTFOREIGN		4	/* foreign terminal (ft1-8) */
#define SMG$K_HARDCOPY		5	/* hardcopy device */
#define SMG$K_VTTERMTABLE	6	/* video terminal */
/* 
 The following masks define values to be used
 to specify a display attribute.  These may be added
 together to specify multiple attributes.
*/
#define SMG$M_BORDER		0X1
#define SMG$M_TRUNC_ICON	0X2
#define SMG$M_DISPLAY_CONTROLS	0X4
#define SMG$M_USER_DISPLAY	0X8
#define SMG$M_UP		0X1
#define SMG$M_DOWN		0X2
#define SMG$M_RIGHT		0X4
#define SMG$M_LEFT		0X8
#define SMG$K_FIRST_PRIV_TYPE	191

#define SMG$S_SMGDEF		32
union SMGDEF {
    struct  {
        unsigned SMG$V_BOLD : 1;        /* Bold rendition                   */
        unsigned SMG$V_REVERSE : 1;     /* Reverse video rendition          */
        unsigned SMG$V_BLINK : 1;       /* Blink rendition                  */
        unsigned SMG$V_UNDERLINE : 1;   /* Underline rendition              */
        } SMG$R_SMGDEF_BITS;
    struct  {
        unsigned SMG$V_BUF_ENABLED : 1; /* Enable buffering                 */
        unsigned SMG$V_MINUPD : 1;      /* Enable minimal update (default)  */
        unsigned SMG$V_CLEAR_SCREEN : 1; /* Clear screen on exit            */
        unsigned SMG$V_NOTABS : 1;      /* Don't use physical tabs          */
        } SMG$R_SMGMODE_BITS;
    struct  {
        unsigned SMG$V_BORDER : 1;      /* Display is bordered              */
        unsigned SMG$V_TRUNC_ICON : 1;  /* Truncation icon enabled if set   */
        unsigned SMG$V_DISPLAY_CONTROLS : 1; /* Display carriage controls if set */
        unsigned SMG$V_USER_DISPLAY : 1; /* User Display for DEBUG if set */
        } SMG$R_DISPLAY_ATTRIBUTES;
/*
 When an out-of-band AST triggers, the user's AST routine
 will get called.  The first argument passed to his
 routine is the address of a Band Information Table.
 The offsets into this table are described below.
 To make it easy to access from certain languages,
 the table is arranged so that it is convenient to
 reference it as a longword vector as well as a byte block.
*/
    struct  {
        unsigned long int SMG$L_PASTEBOARD_ID; /* Pasteboard ID             */
        unsigned long int SMG$L_ARG;    /* User's AST argument              */
        union  {
            unsigned char SMG$B_CHARACTER; /* The character typed           */
            unsigned long int SMG$L_CHARACTER; /* The character and 3 spaces */
            } SMG$R_CHARACTER_OVERLAY;
        } SMG$R_BAND_INFORMATION_TABLE;
/*
 When SMG$GET_PASTEBOARD_ATTRIBUTES is called,
 it returns data in a pasteboard information block.
 The following structure is used to reference fields
 in this block.
 Items marked with a plus (+) will be 0 unless the
 device is a terminal (DEVCLASS=DC$_TERM).
*/
    struct  {
        unsigned long int SMG$L_DEVCHAR; /* Device characteristics          */
        unsigned long int SMG$L_DEVDEPEND; /* Specific characteristics (1)  */
        unsigned long int SMG$L_DEVDEPEND2; /* Specific characteristics (2) */
        unsigned char SMG$B_DEVCLASS;   /* Device class (e.g. DC$_TERM)     */
        unsigned char SMG$B_SMG_DEVTYPE; /* Internal SMG device type        */
        unsigned char SMG$B_PHY_DEVTYPE; /* Physical device type (e.g. DT$_VT100) */
        unsigned char SMG$B_ROWS;       /* Number of rows on device         */
        unsigned short int SMG$W_WIDTH; /* Terminal width                   */
        unsigned char SMG$B_COLOR;      /* Reserved for future use          */
        unsigned char SMG$B_PARITY;     /* Parity attributes (+)            */
        unsigned short int SMG$W_SPEED; /* Terminal Speed (+)               */
        unsigned short int SMG$W_FILL;  /* Fill characteristics (+)         */
        unsigned short int SMG$W_CURSOR_ROW; /* Row where physical cursor is */
        unsigned short int SMG$W_CURSOR_COL; /* Col where physical cursor is */
        unsigned long int SMG$L_CURSOR_DID; /* Display id of topmost        */
					/* display that cursor is in.        */
					/* 0 if cursor is not in a           */
					/* virtual display                   */
        } SMG$R_PASTEBOARD_INFO_BLOCK;
/*
 When SMG$GET_KEYBOARD_ATTRIBUTES is called,
 it returns data in a keyboard information block.
 The following structure is used to reference fields in this block.
 Items marked with a plus (+) will be 0 unless the
 device is a terminal (DEVCLASS=DC$_TERM).
*/
    struct  {
        unsigned long int SMG$L_DEVCHAR; /* Device characteristics          */
        unsigned long int SMG$L_DEVDEPEND; /* Specific characteristics (1)  */
        unsigned long int SMG$L_DEVDEPEND2; /* Specific characteristics (2) */
        unsigned char SMG$B_DEVCLASS;   /* Device class (e.g. DC$_TERM)     */
	unsigned char SMG$B_RECALL_SIZE; /* size of recall buffer (+) */
        unsigned char SMG$B_PHY_DEVTYPE; /* Physical device type (e.g. DT$_VT100) */
	unsigned char SMG$B_TYPEAHEAD_CHAR; /* first char in typeahead buffer (+) */
        unsigned short int SMG$W_WIDTH; /* Terminal width                   */
	unsigned short SMG$W_TYPEAHEAD_COUNT; /* number of chars in typeahead buffer (+) */
        } SMG$R_KEYBOARD_INFO_BLOCK;
/*
 Directions are set up as a structure, assuming that directions
 may be combined in the future (ie. diagonal movement).
*/
    struct  {
        unsigned SMG$V_UP : 1;          /* Scroll up                        */
        unsigned SMG$V_DOWN : 1;        /* Scroll down                      */
        unsigned SMG$V_RIGHT : 1;       /* Scroll right                     */
        unsigned SMG$V_LEFT : 1;        /* Scroll left                      */
        } SMG$R_SCROLL_DIRS;
    } ;
