.IFDEF	DEBUG
CFLAGS	= /DEBUG /NOOPTIMIZE /OBJECT=$(MMS$TARGET_NAME)
LINKFLAGS = /DEBUG /NOMAP /EXECUTABLE=$(MMS$TARGET_NAME)
.ELSE
LINKFLAGS = /NOTRACEBACK /NOMAP /EXECUTABLE=$(MMS$TARGET_NAME)
.ENDIF
!
! Descriptions to build XDFO.EXE
!
XDFO.EXE	: XDFO.OBJ, XDFO_MSG.OBJ, XDFO_TABLES.OBJ
		$(LINK) $(LINKFLAGS) $(MMS$SOURCE_LIST),  -
			SYS$LIBRARY:VAXCRTL/OPTIONS

XDFO.OBJ	: XDFO.C, VAXOBJ.H

XDFO_MSG.OBJ	: XDFO.MSG
		MESSAGE $(MSGFLAGS) $(MMS$SOURCE)

XDFO_TABLES.OBJ	: XDFO.CLD
		SET COMMAND /OBJECT=$(MMS$TARGET_NAME) $(CLDFLAGS) $(MMS$SOURCE)

.LAST		:
	@	PURGE
!
! Make listing files 
!
LISTINGS	: XDFO.LIS, XDFO_MSG.LIS, XDFO_TABLES.LIS
	@	DIRECTORY /SIZE  *.LIS

XDFO.LIS	: XDFO.C, VAXOBJ.H
		CC /LIST=$(MMS$TARGET_NAME) /SHOW=SYMBOLS /NOOBJECT -
			$(MMS$SOURCE)

XDFO_MSG.LIS	: XDFO.MSG
		MESSAGE /LIST=$(MMS$TARGET_NAME) /NOOBJECT $(MMS$SOURCE)

XDFO_TABLES.LIS	: XDFO.CLD
		SET COMMAND /LIST=$(MMS$TARGET_NAME) /NOOBJECT $(MMS$SOURCE)
!
! Cleanup object files
!
CLEANUP		:
	-	DELETE *.OBJ;*,*.LIS;*
